//+------------------------------------------------------------------+
//|                                                          SSL.mq4 |
//|ssl  fast bar mtf                                         Kalenzo |
//|                                      bartlomiej.gorski@gmail.com |
//+------------------------------------------------------------------+
//mtf2008fxtsd   

#property copyright "Kalenzo"
#property link      "bartlomiej.gorski@gmail.com"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1  Green
#property indicator_color2  Red
#property indicator_width1  3
#property indicator_width2  3
#property indicator_minimum 10
#property indicator_maximum 90

//
//
//
//
//

extern int     Lb           = 3;
extern int     sslMA_method =  0;
extern int     SSL_BarLevel = 50;    //BarLevel 10-90

extern bool alertsOn             = false;
extern bool alertsMessageBox     = false;
extern bool alertsSound          = false;
extern string alertsSoundFile    = "alert2.wav";  //enterSoundFile
extern bool alertsEmail          = false;
extern bool alertsAfterBarClose  = false;
extern bool   ShowArrows              = false;
extern string arrowsIdentifier        = "ssl arrows1";
extern double arrowsUpperGap          = 1.0;
extern double arrowsLowerGap          = 1.0;
extern color  arrowsUpColor           = LimeGreen;
extern color  arrowsDnColor           = Red;
extern int    arrowsUpCode            = 241;
extern int    arrowsDnCode            = 242;

extern int     TimeFrame    =  0;
extern string  TimeFrames   = "M1;5,15,30,60H1;240H4;1440D1;10080W1;43200MN|0-CurrentTF";
extern string  MA_method_   = "SMA0 EMA1 SMMA2 LWMA3";

//
//
//
//
//

double sslHup[];
double sslHdn[];
double hlv[];
string IndicatorFileName;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   string TimeFrameStr;
   TimeFrame=MathMax(TimeFrame,Period());
   IndicatorFileName = WindowExpertName();
      
      switch(TimeFrame)
      {
         case PERIOD_M1:  TimeFrameStr="M1"  ; break;
         case PERIOD_M5:  TimeFrameStr="M5"  ; break;
         case PERIOD_M15: TimeFrameStr="M15" ; break;
         case PERIOD_M30: TimeFrameStr="M30" ; break;
         case PERIOD_H1:  TimeFrameStr="H1"  ; break;
         case PERIOD_H4:  TimeFrameStr="H4"  ; break;
         case PERIOD_D1:  TimeFrameStr="D1"  ; break;
         case PERIOD_W1:  TimeFrameStr="W1"  ; break;
         case PERIOD_MN1: TimeFrameStr="MN1" ; break;
         default :        TimeFrameStr="TF0";
      } 


   IndicatorBuffers(3);
   SetIndexBuffer (0,sslHup); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,167); SetIndexLabel(0,"SSLup "+Lb+" ["+TimeFrame+"]");
   SetIndexBuffer (1,sslHdn); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,167); SetIndexLabel(1,"SSLdn "+Lb+" ["+TimeFrame+"]");
   SetIndexBuffer (2,hlv);

   IndicatorShortName("SSL Bar "+Lb+" ["+TimeFrameStr+"]");

   return(0);
}


int deinit() 
{  
   deleteArrows(); 
   
return(0); 
}

//
//
//
//
//

int start()
 {
   int  counted_bars=IndicatorCounted();
      if (counted_bars<0) return(-1);
      if (counted_bars>0) counted_bars--;
            int limit=Bars-counted_bars;


   if (TimeFrame != Period())
   {
      datetime TimeArray[];
         limit = MathMax(limit,3*TimeFrame/Period());
         
         //
         //
         //
         //
         //

         for(int i=limit;i>=0;i--)
         {
            int y = iBarShift(NULL,TimeFrame,Time[i]);

            sslHup[i] = iCustom(NULL,TimeFrame,IndicatorFileName,Lb,sslMA_method,SSL_BarLevel,alertsOn,alertsMessageBox,
                                             alertsSound,alertsSoundFile,alertsEmail,alertsAfterBarClose,false,0,y);
            sslHdn[i] = iCustom(NULL,TimeFrame,IndicatorFileName,Lb,sslMA_method,SSL_BarLevel,alertsOn,alertsMessageBox,
                                             alertsSound,alertsSoundFile,alertsEmail,alertsAfterBarClose,false,1,y);
            hlv[i]    = iCustom(NULL,TimeFrame,IndicatorFileName,Lb,sslMA_method,SSL_BarLevel,alertsOn,alertsMessageBox,
                                             alertsSound,alertsSoundFile,alertsEmail,alertsAfterBarClose,false,2,y);
               if (ShowArrows)
               {
                 deleteArrow(Time[i]);
                 if (hlv[i] != hlv[i+1])
                 {
                   if (hlv[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                   if (hlv[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
                 }
              }


         }
   
         
      return(0);         
   }

 
   //
   //
   //
   //
   //
    
   for(i=limit;i>=0;i--)
   {
      hlv[i] = hlv[i+1];
 
         if(Close[i]>iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_HIGH,i+1))  hlv[i] =  1;
         if(Close[i]<iMA(Symbol(),0,Lb,0,MODE_SMA,PRICE_LOW, i+1))  hlv[i] = -1;
      
         if(hlv[i] == -1) { sslHdn[i] = SSL_BarLevel; sslHup[i] = EMPTY_VALUE;  }
         else             { sslHdn[i] = EMPTY_VALUE;  sslHup[i] = SSL_BarLevel; }                  
               if (ShowArrows)
               {
                 deleteArrow(Time[i]);
                 if (hlv[i] != hlv[i+1])
                 {
                   if (hlv[i] == 1)  drawArrow(i,arrowsUpColor,arrowsUpCode,false);
                   if (hlv[i] ==-1)  drawArrow(i,arrowsDnColor,arrowsDnCode, true);
                 }
              }

   }
   
  
   if (alertsOn)
   {
      int alertBar=0; 
      if (alertsAfterBarClose)alertBar = 1;

      if (hlv[0+alertBar] != hlv[1+alertBar])
      if (hlv[0+alertBar] == 1)
            doAlert("Up");
      else  doAlert("Down");    
   }



   return(0);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//

void drawArrow(int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+Time[i];
   double gap  = iATR(NULL,0,20,i);   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//

void doAlert(string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[0]) 
      
      {
          previousAlert  = doWhat;
          previousTime   = Time[0];

          //
          //
          //

          message =  StringConcatenate(Symbol()," M",TimeFrame," at ",Close[0]," SSL Bar: trend changed to ",doWhat);
             if (alertsMessageBox)  Alert(message);
             if (alertsEmail)       SendMail(StringConcatenate(Symbol(),"SSL "),message);
             if (alertsSound)       PlaySound(alertsSoundFile);
      }
}

